config/routes.rb
Rails.application.routes.draw do
  resources :plans
  resources :purchases
  resources :businesses do
    collection do
      get 'show_new'=>'businesses#show_new'
    end
    resources :categories
    resources :products
  end
  get 'home/index'
  get 'home1'=>'home#home_1'
  get 'new_products'=>'products#new_index'
  root 'home#index'
  devise_for :users, :controllers => {:registrations => "registrations"}
  resource :user, only: [:edit] do
	  collection do
	    patch 'update_password'
	  end
	end
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/product.rb
class Product < ApplicationRecord
    belongs_to :category
    belongs_to :business
    belongs_to :product_type, :optional=> true
end

app/models/product_type.rb
class ProductType < ApplicationRecord
    has_many :products
end

app/controllers/products_controller.rb
class ProductsController < ApplicationController
  before_action :set_product, only: [:show, :edit, :update, :destroy]
  before_action :set_business, :set_categories, except: [:new_index]

  # GET /products
  # GET /products.json
  def index
    @products = Product.all
  end

  def new_index
    render :layout=>'menu'
  end

  # GET /products/1
  # GET /products/1.json
  def show
  end

  # GET /products/new
  def new
    @product = Product.new
  end

  # GET /products/1/edit
  def edit
  end

  # POST /products
  # POST /products.json
  def create
    @product = Product.new(product_params)
    @product.business_id = @business.id
    respond_to do |format|
      if @product.save
        format.html { redirect_to business_products_path(@business), notice: 'Product was successfully created.' }
        format.json { render :show, status: :created, location: @product }
      else
        format.html { render :new }
        format.json { render json: @product.errors, status: :unprocessable_entity } 
      end
    end
  end

  # PATCH/PUT /products/1
  # PATCH/PUT /products/1.json
  def update
    respond_to do |format|
      if @product.update(product_params)
        format.html { redirect_to business_products_path(@business), notice: 'Product was successfully updated.' }
        format.json { render :show, status: :ok, location: @product }
      else
        format.html { render :edit }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /products/1
  # DELETE /products/1.json
  def destroy
    @product.destroy
    respond_to do |format|
      format.html { redirect_to business_products_path(@business), notice: 'Product was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_product
      @product = Product.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def product_params
      params.require(:product).permit(:category_id, :name, :food_type, :half_price, :full_price, :ac_half_price, :ac_full_price, :description, :product_type_id, :business_id, :unit, :price)
    end
    
    def set_business
      @business = Business.find_by_id(params[:business_id])
    end
    def set_categories
      @categories = @business.categories
    end
end

app/helpers/products_helper.rb
module ProductsHelper
end

app/views/products/_form.html.erb
<div class="row page-titles">
  <div class="col-md-5 align-self-center">
    <!-- <h4 class="text-themecolor">Business New</h4> -->
  </div>
  <div class="col-md-7 align-self-center text-right">
    <div class="d-flex justify-content-end align-items-center">
      <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="javascript:void(0)">Home</a></li>
        <li class="breadcrumb-item active">Product</li>
      </ol>
    </div>
  </div>
</div>
<div class="row">
  <!-- Column -->
  <div class="col-lg-6 col-sm-12 offset-lg-3">
    <div class="card">
      <div class="card-body">
        <h5 class="card-title"><%= params[:action].titleize %> Product</h5>
        <hr>
        <% if @business.business_type == "restaurant"%>
          <%= render :partial=>'restaurant_form'%>
        <% else %>
          <%= render :partial=>'vegetable_seller_form'%>
        <% end %>
      </div>
    </div>
  </div>
</div>      

app/views/products/_restaurant_form.html.erb
<%= form_for [@business, @product] do |form| %>


<div class="form-group row">
  <label for="staticEmail" class="col-sm-3 col-form-label">Category</label>
  <div class="col-sm-9">
    <%= form.select :category_id, options_for_select(@categories.pluck(:name, :id), form.object.category_id), {:prompt => 'Select Category'}, {:class => 'form-control select2 select-phases', :required => true}%>
  </div>
</div>


<div class="form-group row">
  <label for="staticEmail" class="col-sm-3 col-form-label">Name</label>
  <div class="col-sm-9">    
    <%= form.text_field :name, id: :product_name, :class=>"form-control", :required => true %>
  </div>
</div>

<div class="form-group row">
  <label for="staticEmail" class="col-sm-3 col-form-label">Food Type</label>
  <div class="col-sm-9">    
    <%= form.select :food_type, options_for_select(FOOD_TYPES, form.object.food_type), {:prompt => 'Select Food Type'}, {:class => 'form-control select2 select-phases', :required => true}%>
  </div>
</div>

<div class="form-group row">
  <label for="staticEmail" class="col-sm-3 col-form-label">Half Price</label>
  <div class="col-sm-9">    
    <%= form.text_field :half_price, id: :product_half_price, :class=>"form-control" %>
  </div>
</div>

<div class="form-group row">
  <label for="staticEmail" class="col-sm-3 col-form-label">Full Price</label>
  <div class="col-sm-9">    
    <%= form.text_field :full_price, id: :product_full_price, :class=>"form-control" %>
  </div>
</div>

<div class="form-group row">
  <label for="staticEmail" class="col-sm-3 col-form-label">AC Half Price</label>
  <div class="col-sm-9">    
    <%= form.text_field :ac_half_price, id: :product_ac_half_price, :class=>"form-control" %>
  </div>
</div>

<div class="form-group row">
  <label for="staticEmail" class="col-sm-3 col-form-label">AC Full Price</label>
  <div class="col-sm-9">    
    <%= form.text_field :ac_full_price, id: :product_ac_full_price, :class=>"form-control" %>
  </div>
</div>

<div class="form-group row">
  <label for="staticEmail" class="col-sm-3 col-form-label">Description</label>
  <div class="col-sm-9">    
    <%= form.text_area :description, id: :product_description, :class=>"form-control" %>
  </div>
</div>

<div class="form-group row">
  <label for="staticEmail" class="col-sm-3 col-form-label">Product Type</label>
  <div class="col-sm-9">    
    <%= form.select :product_type_id, options_for_select(ProductType.pluck(:name, :id), form.object.product_type_id), {:prompt => 'Select Type'}, {:class => 'form-control select2 select-phases'}%>
  </div>
</div>

<hr>
<div class="form-actions m-t-40">
  <button type="submit" class="btn btn-success"> <i class="fa fa-check"></i> Save</button>
  <a type="button" class="btn btn-dark" href="<%= business_categories_path(current_user.business)%>">Cancel</a>
</div>
<% end %>

app/views/products/_restaurant_list.html.erb
<table class="table table-striped table-bordered no-wrap" id="zero_config">
  <thead>
    <tr>
      <th>Category</th>
      <th>Name</th>
      <th>Food type</th>
      <th>Half price</th>
      <th>Full price</th>
      <th>Ac half price</th>
      <th>Ac full price</th>
      <th>Description</th>
      <th>Product type</th>
      <th >Actions</th>
    </tr>
  </thead>

  <tbody>
    <% @products.each do |product| %>
    <tr>
      <td><%= product.category.name %></td>
      <td><%= product.name %></td>
      <td><%= product.food_type %></td>
      <td><%= product.half_price %></td>
      <td><%= product.full_price %></td>
      <td><%= product.ac_half_price %></td>
      <td><%= product.ac_full_price %></td>
      <td><%= product.description %></td>
      <td><%= product.product_type.name rescue '' %></td>
      <td><%= link_to 'Edit', edit_business_product_path(@business, product) %>
        <%= link_to 'Destroy', business_product_path(@business,product), method: :delete, data: { confirm: 'Are you sure?' } %>
      </td>
    </tr>
    <% end %>
  </tbody>
</table>

app/views/products/_vegetable_seller_form.html.erb
<%= form_for [@business, @product] do |form| %>


<div class="form-group">
  <%= form.label :category_id %>
  <%= form.select :category_id, options_for_select(@categories.pluck(:name, :id), form.object.category_id), {:prompt => 'Select Category'}, {:class => 'form-control select2 select-phases'}%>
</div>

<div class="form-group">
  <%= form.label :name %>
  <%= form.text_field :name, id: :product_name, :class=>"form-control" %>
</div>


<div class="form-group">
  <%= form.label :description %>
  <%= form.text_area :description, id: :product_description, :class=>"form-control" %>
</div>



<div class="form-group">
  <%= form.label :unit %>
  <%= form.select :unit, options_for_select(UNITS, form.object.unit), {:prompt => 'Select Unit'}, {:class => 'form-control select2 select-phases'}%>
</div>

<div class="form-group">
  <%= form.label :price %>
  <%= form.text_field :price, id: :product_price, :class=>"form-control" %>
</div>

<hr>
<div class="form-actions m-t-40">
  <button type="submit" class="btn btn-success"> <i class="fa fa-check"></i> Save</button>
  <a type="button" class="btn btn-dark" href="<%= business_categories_path(current_user.business)%>">Cancel</a>
</div>
<% end %>

app/views/products/_vegetable_seller_list.html.erb
<table class="table table-striped table-bordered no-wrap" id="zero_config">
<thead>
<tr>
    <th>Category</th>
    <th>Name</th>
    <th>Description</th>
    <th>Unit</th>
    <th>Price</th>
    <th ></th>
</tr>
</thead>

<tbody>
<% @products.each do |product| %>
    <tr>
    <td><%= product.category_id %></td>
    <td><%= product.name %></td>
    <td><%= product.description %></td>
    <td><%= product.unit %></td>
    <td><%= product.price %></td>
    <td><%= link_to 'Edit', edit_business_product_path(@business, product) %> <%= link_to 'Destroy', business_product_path(@business,product), method: :delete, data: { confirm: 'Are you sure?' } %></td>
    </tr>
<% end %>
</tbody>
</table>

app/views/products/edit.html.erb
<%= render 'form', product: @product, business: @business %>

app/views/products/index.html.erb
<div class="row page-titles">
  <div class="col-md-5 align-self-center">
      <h4 class="text-themecolor">Products</h4>
  </div>
  <div class="col-md-7 align-self-center text-right">
      <div class="d-flex justify-content-end align-items-center">
          <ol class="breadcrumb">
              <li class="breadcrumb-item"><a href="javascript:void(0)">Home</a></li>
              <li class="breadcrumb-item active">Products</li>
          </ol>
          <a type="button" class="btn btn-info d-none d-lg-block m-l-15" href="<%=new_business_product_path(current_user.business)%>"><i class="fa fa-plus-circle"></i> Create New</a>
      </div>
  </div>
</div>

<div class="row">
  <div class="col-lg-12">
    <div class="card">
        <div class="card-body">
            <div class="table-responsive">
                  <% if @business.business_type == "restaurant"%>
                    <%= render :partial=>'restaurant_list'%>
                  <% else %>
                    <%= render :partial=>'vegetable_seller_list'%>
                  <% end %>
              </div>
            </div>
        </div>
    </div>
</div>

<script>
  $(function(){
      $('#zero_config').DataTable();

  })
</script>

app/views/products/new.html.erb
<%= render 'form', product: @product, business: @business %>

app/views/products/new_index.html.erb
<div class="list-section">
    <div class="wrap-list-rc">
        <div class="heading-page">
            All food recipes
            <div class="back-btn">
                <div class="icon-back"><i class="fas fa-chevron-left"></i></div>

            </div>
        </div>

        <div class="lrc-item">
            <a href="#">
                <div class="lrc-content">
                    <div class="lrc-img">
                        <img src="img/food5.jpg" alt="item">
                    </div>
                    <div class="lrc-desc">
                        <div class="lrc-title">Woku Fish Belanga</div>
                        <div class="lrc-text">
                            White salmon / 2 tuna, salt, lime, vegetable oil, curly red chili
                        </div>
                        <div class="lrc-button">
                            <div class="lrcb-left">
                                <span class="lhc like"><i class="fas fa-heart"></i> 5</span>
                                <span class="lhc hours"><i class="fas fa-clock"></i> 27m</span>
                                <span class="lhc comment"><i class="fas fa-comment-alt"></i> 0</span>
                            </div>
                            <div class="lrcb-right">

                            </div>
                            <div class="clear"></div>
                        </div>
                    </div>
                </div>
            </a>
        </div>


        <div class="lrc-item">
            <a href="#">
                <div class="lrc-content">
                    <div class="lrc-img">
                        <img src="img/news2.jpg" alt="item">
                    </div>
                    <div class="lrc-desc">
                        <div class="lrc-title">Vegetable Corn Soup</div>
                        <div class="lrc-text">
                            chicken wings, sweet corn, carrots, cabbage, leeks, celery
                        </div>
                        <div class="lrc-button">
                            <div class="lrcb-left">
                                <span class="lhc like"><i class="fas fa-heart"></i> 9</span>
                                <span class="lhc hours"><i class="fas fa-clock"></i> 40m</span>
                                <span class="lhc comment"><i class="fas fa-comment-alt"></i> 5</span>
                            </div>
                            <div class="lrcb-right">

                            </div>
                            <div class="clear"></div>
                        </div>
                    </div>
                </div>
            </a>
        </div>


        <div class="lrc-item">
            <a href="#">
                <div class="lrc-content">
                    <div class="lrc-img">
                        <img src="img/food12.jpg" alt="item">
                    </div>
                    <div class="lrc-desc">
                        <div class="lrc-title">Miso soup</div>
                        <div class="lrc-text">
                            Bamboo shoot, Cabbage, Carrot, Corn, Eggplant, Green pepper, Mushroom, Onion
                        </div>
                        <div class="lrc-button">
                            <div class="lrcb-left">
                                <span class="lhc like"><i class="fas fa-heart"></i> 7</span>
                                <span class="lhc hours"><i class="fas fa-clock"></i> 34m</span>
                                <span class="lhc comment"><i class="fas fa-comment-alt"></i> 3</span>
                            </div>
                            <div class="lrcb-right">

                            </div>
                            <div class="clear"></div>
                        </div>
                    </div>
                </div>
            </a>
        </div>


        <div class="lrc-item">
            <a href="#">
                <div class="lrc-content">
                    <div class="lrc-img">
                        <img src="img/food8.jpg" alt="item">
                    </div>
                    <div class="lrc-desc">
                        <div class="lrc-title">Simple Fried Rice</div>
                        <div class="lrc-text">
                            Rice, meatballs, eggs, salt, flavoring, sweet soy sauce, garlic, red chili
                        </div>
                        <div class="lrc-button">
                            <div class="lrcb-left">
                                <span class="lhc like"><i class="fas fa-heart"></i> 4</span>
                                <span class="lhc hours"><i class="fas fa-clock"></i> 15m</span>
                                <span class="lhc comment"><i class="fas fa-comment-alt"></i> 1</span>
                            </div>
                            <div class="lrcb-right">

                            </div>
                            <div class="clear"></div>
                        </div>
                    </div>
                </div>
            </a>
        </div>
        <div class="lrc-item">
            <a href="#">
                <div class="lrc-content">
                    <div class="lrc-img">
                        <img src="img/food14.jpg" alt="item">
                    </div>
                    <div class="lrc-desc">
                        <div class="lrc-title">Crispy chicken</div>
                        <div class="lrc-text">
                            Medium Cut Chicken, Tapioca Flour, Wheat Flour, Egg, Little Water, Flavoring Flavor
                        </div>
                        <div class="lrc-button">
                            <div class="lrcb-left">
                                <span class="lhc like"><i class="fas fa-heart"></i> 2</span>
                                <span class="lhc hours"><i class="fas fa-clock"></i> 35m</span>
                                <span class="lhc comment"><i class="fas fa-comment-alt"></i> 5</span>
                            </div>
                            <div class="lrcb-right">

                            </div>
                            <div class="clear"></div>
                        </div>
                    </div>
                </div>
            </a>
        </div>
        <div class="lrc-item">
            <a href="#">
                <div class="lrc-content">
                    <div class="lrc-img">
                        <img src="img/food6.jpg" alt="item">
                    </div>
                    <div class="lrc-desc">
                        <div class="lrc-title">Grilled fish</div>
                        <div class="lrc-text">
                            Medium fish, Salt, Soysauce
                        </div>
                        <div class="lrc-button">
                            <div class="lrcb-left">
                                <span class="lhc like"><i class="fas fa-heart"></i> 4</span>
                                <span class="lhc hours"><i class="fas fa-clock"></i> 15m</span>
                                <span class="lhc comment"><i class="fas fa-comment-alt"></i> 1</span>
                            </div>
                            <div class="lrcb-right">

                            </div>
                            <div class="clear"></div>
                        </div>
                    </div>
                </div>
            </a>
        </div>
        <div class="lrc-item">
            <a href="#">
                <div class="lrc-content">
                    <div class="lrc-img">
                        <img src="img/food2.jpg" alt="item">
                    </div>
                    <div class="lrc-desc">
                        <div class="lrc-title">Happy eggplant</div>
                        <div class="lrc-text">
                            Sugar, Soysauce, Miso paste
                        </div>
                        <div class="lrc-button">
                            <div class="lrcb-left">
                                <span class="lhc like"><i class="fas fa-heart"></i> 4</span>
                                <span class="lhc hours"><i class="fas fa-clock"></i> 15m</span>
                                <span class="lhc comment"><i class="fas fa-comment-alt"></i> 1</span>
                            </div>
                            <div class="lrcb-right">

                            </div>
                            <div class="clear"></div>
                        </div>
                    </div>
                </div>
            </a>
        </div>


    </div>
    <div class="wrap-pagination">
        <ul class="pagination">
            <li class="page-item"><a class="page-link" href="#">Previous</a></li>
            <li class="page-item"><a class="page-link" href="#">1</a></li>
            <li class="page-item active"><a class="page-link" href="#">2</a></li>
            <li class="page-item"><a class="page-link" href="#">3</a></li>
            <li class="page-item"><a class="page-link" href="#">4</a></li>
            <li class="page-item"><a class="page-link" href="#">Next</a></li>
        </ul>
    </div>
</div>

app/views/products/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Category:</strong>
  <%= @product.category_id %>
</p>

<p>
  <strong>Name:</strong>
  <%= @product.name %>
</p>

<p>
  <strong>Food type:</strong>
  <%= @product.food_type %>
</p>

<p>
  <strong>Half price:</strong>
  <%= @product.half_price %>
</p>

<p>
  <strong>Full price:</strong>
  <%= @product.full_price %>
</p>

<p>
  <strong>Ac half price:</strong>
  <%= @product.ac_half_price %>
</p>

<p>
  <strong>Ac full price:</strong>
  <%= @product.ac_full_price %>
</p>

<p>
  <strong>Description:</strong>
  <%= @product.description %>
</p>

<p>
  <strong>Product type:</strong>
  <%= @product.product_type_id %>
</p>

<p>
  <strong>Business:</strong>
  <%= @product.business_id %>
</p>

<p>
  <strong>Unit:</strong>
  <%= @product.unit %>
</p>

<p>
  <strong>Price:</strong>
  <%= @product.price %>
</p>

<%= link_to 'Edit', edit_product_path(@product) %> |
<%= link_to 'Back', products_path %>